<!doctype html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>GMDPtoolbox</title>
	<link rel="stylesheet" href="styles.css" type="text/css" media="screen">
	<link rel="stylesheet" type="text/css" href="print.css" media="print">
        <meta name="description" content="Graph-based Markov Decision Processes Toolbox for MATLAB">
        <meta name="keywords" content="Graph-based Markov decision process, GMDP, Toolbox, MATLAB">
	<!--[if IE]><script src="http://html5shiv.googlecode.com/svn/trunk/html5.js"></script><![endif]-->
</head>
<body>
<div id="wrapper"><!-- #wrapper -->

	<nav><!-- top nav -->
		<div class="menu">
		<ul class="dockmenu">
			<li><a href="home.html"><img src="icons/home.png" alt="Home" title="Home" width="64"></a></li> 
			<li><a href="install.html"><img src="icons/down.png" alt="Install" title="Install" width="64"></a></li> 
			<li><a href="documentation.html"><img src="icons/doc.png" alt="Documentation" title="Documentation" width="64"></a></li> 
		</ul>
		</div>
	</nav><!-- end of top nav -->
	
	<header><!-- header -->
		<h1><font color="red">G</font><font color="#2e64fe">MDP</font><font color="black">toolbox</font></h1>
		<h2>Matlab tools for Graph-based Markov Decision Processes</h2>
	</header><!-- end of header -->
	
	<div id="main"><!-- #main content and sidebar area -->
			<div id="content"><!-- #content -->
			
        		       <article>
					<h2>Download GMDPtoolbox</h2>
					<p>From the
<a href="http://www.mathworks.com/matlabcentral/fileexchange/49101-graph-based-markov-decision-processes--gmdp--toolbox">MatlabCentral page</a>
or <a href="https://sourcesup.renater.fr/frs/?group_id=3700">Project Forge Files page</a>
<b>download the file gmdptoolbox.zip</b>.<br>
Unzip the file and go to the created directory.<br>
On Linux system execute the following system commands: <br>
&nbsp;&nbsp;&nbsp;&nbsp;<b>unzip gmdptoolbox.zip<br>
&nbsp;&nbsp;&nbsp;&nbsp;cd gmdptoolbox</b></p>

GMDPtoolbox relies on graphViz4Matlab toolbox to display graphs. Download this toolbox, 
from <a href="http://www.mathworks.com/matlabcentral/fileexchange/21652-graphviz4matlab">MatlabCentral</a> in the gmdptoolbox directory.<br>
Unzip the file.<br>
On Linux system execute the following system command: <br>
&nbsp;&nbsp;&nbsp;&nbsp;<b>unzip graphViz4Matlab_03Mar2010.zip</b><br>
 <br>
To use the toolbox in a MATLAB session, add the gmdptoolbox directory and subdirectories to search path.
Execute the following MATLAB commands:<br>
&nbsp;&nbsp;&nbsp;&nbsp;<b>>> GMDPtoolbox_path = pwd;<br>
&nbsp;&nbsp;&nbsp;&nbsp;>> addpath(genpath(GMDPtoolbox_path))</b><br>
In this MATLAB session, it is then possible to use all the GMDPtoolbox functions.</p>

<p>To access the PDF user documentation, open the file <a href="ReferenceManual.pdf">doc/ReferenceManual.pdf</a> with an appropriate software.<br>
</p>
			       </article>
			
        		       <article>
					<h2>Quick start</h2>
					<p>To quickly learn how to use the toolbox, open the file  <a href="QuickStart.pdf">doc/QuickStart.pdf</a> with an appropriate software.</p>
			       </article>

        		       <article>
<a id="FAQ">				<h2>FAQ</h2>
If you not have found below the answer at your question or to suggest a feature, add a request on the <a href="https://sourcesup.renater.fr/tracker/?atid=6385&group_id=3700&func=browse">Bugs and Feature request of the project</a>.<br>
<br>
<br>
<span class="blue">* Why can I not visualize a graph with a function should open a figure window ?</span><br>
<br>
First, be sure to have added the path to graphViz4Matlab toolbox directory and sub-directories in search paths of your MATLAB session (see above procedure).<br>
<br>
Second, check if you are allowed to write files in the current directory when the function is called. A temporary file has to be written before displaying the graph in a MATLAB figure window.<br>
<br>
Third, check the installation of graphViz4Matlab toolbox. in MATLAB, add the toolbox directory and sub-directories to search paths.
Try to execute the following command: 'demos/graphViz4MatlabDEMO1'. A MATLAB figure window must open.<br>
<br>
Finally, be sure that graphviz is installed and accessible. Test the dot command, try to execute in a system window 'dot -V'.
The version should be displayed: 'dot - graphviz version 2.38.0 (20140413.2041)'.<br>
<br>
<br>
<span class="blue">* What is the 'parfor' instruction in gmdp_policy_iteration_MF function ?</span><br>
<br>
When the MATLAB Parallel Computing Toolbox is available, execute loop iterations in parallel.<br>
<br>
<br>
<span class="blue">* I do not have the MATLAB Parallel toolbox ?</span><br>
<br>
Change 'parfor' in 'for' in the code of the 2 resolution functions: gmdp_linear_programming and gmdp_policy_iteration_MF.<br>
<br>
<br>
<span class="blue">* The following functions gmdp_eval_policy_value, gmdp_eval_policy_value_site _contribution, 
gmdp_eval_policy_state_time do not handle a GMDP with 1 site ?</span><br>
<br>
This is a limit case for a GMDP. These functions test the size of the variables created by gmdp_simulate_policy.
One of the dimension is the number of site, so the variables are seen in 2 dimensions.<br>
Just comment the dimension test at the beginning of the function, it then run well.<br>
<br>
<br>
<span class="blue">* Error with graphViz4Matlab: "There is no DisplayName property on the Rectangle class.
Error in graphViz4MatlabNode/drawNode" ?</span><br>
<br>
The error was find with the following call:<br>
>>value_site = gmdp_eval_policy_value_site_contribution(GMDP, discount, sim_reward);<br>
Error using rectangle<br>
There is no DisplayName property on the Rectangle class.<br>
Error in graphViz4MatlabNode/drawNode (line 193)<br>
obj.rechandle = rectangle(...<br>
<br>
To avoid it, edit the file graphViz4Matlab_03Mar2010/util/graphViz4MatlabNode.m<br>
and remove the line 201:<br>
'DisplayName' ,obj.label ,....<br>
			       </article>

			</div><!-- end of #content -->

		<aside id="sidebar"><!-- sidebar -->
				<h3>News</h3>
		                Jan. 2018: Change Forge<br>
				Sep. 2016: version 1.1<br>
				Jan. 2015: version 1.0 <br>
				Nov. 2014: version beta2 
                                <br><br>

		</aside><!-- end of sidebar -->

	</div><!-- end of #main content and sidebar-->
	
		<footer>
		<div id="footer-area">

			<div id="footer-outer-block">
					<aside class="footer-segment">
                                        Last update: January 4, 2018
					</aside><!-- end of #fourth footer segment -->

			</div><!-- end of footer-outer-block -->

		</div><!-- end of footer-area -->
	</footer>
	
</div><!-- #wrapper -->
</body>
</html>
